/*
   SHOWPCX.C

   A program which reads in a PCX file
   and displays the image on screen.

   Compiled using Borland C ver 3.1, but should work with any compiler
   with minimal modifications.
*/


#include <stdio.h>     /* printf and what not */
#include <stdlib.h>    /* atol                */
#include <dos.h>       /* MK_FP               */
#include <alloc.h>     /* calloc              */
#include <conio.h>     /* kbhit               */
#include <mem.h>       /* memcpy              */
#include "pcx.h"


/* Pointer to Video RAM */
unsigned far char *Video;


/* function prototypes */
void setmode(int mode);
void setPalette(unsigned char * p);




/*_________________________________________________________________________
 |                                                                         |
 | main(void)                                                              |
 | main entry point for program.                                           |
 |_________________________________________________________________________|*/
void main(int argc, char **argv)
{
FILE *fp;
PCX *Image1;


   /* allocate memory for our pcx image */
   Image1 = calloc(1, sizeof(PCX));

   /* read the PCX file (our PCX file is named T1.PCX) */
   PcxLoad("T1.PCX")

   /* display PCX information */
   PcxDisplayHeader

   // initialize video to graphics mode 13h
   setmode(0x13);

   /* THIS is BORLAND specific...
      if you are using another compiler you will need to modify. */
   /* create our display buffer */
   Video = MK_FP(0xA000,0);

   /* set the palette registers based on the palette in the PCX file */
   setPalette(pcx->palette);

   /* display the image */
   memcpy(Video, pcx->image, pcx->imageSize);

   /* wait for a keypress */
   while (!kbhit()) ;


   /* restore video to text mode 3 */
   setmode(3);
}


/*_________________________________________________________________________
 |                                                                         |
 | setmode()                                                               |
 | sets the video mode to the desired mode.                                |
 |_________________________________________________________________________|*/
   /* THIS is BORLAND specific...
      if you are using another compiler you will need to modify. */
void setmode(int mode)
{
   asm {
      mov ax,mode
      int 10h
      };
}




/*_________________________________________________________________________
 |                                                                         |
 | setPalette()                                                            |
 | initilaize the VGA palette registers.                                   |
 |_________________________________________________________________________|*/
void setPalette(unsigned char * p)
{
union REGS r;
struct SREGS sr;
int i;

   /* Convert 8 bits to 6 bits */
   for (i=0; i<768; i++)
      p[i] = p[i] >> 2;
   r.x.ax = 0x1012;             /* vga set palette function */
   r.x.bx = 0x00;               /* bx = 0                   */
   r.x.cx = 256;                /* cx = 256                 */
   r.x.dx = FP_OFF(p);          /* dx = p(offset)           */
   sr.es  = FP_SEG(p);          /* si = p(segment)          */
   int86x(0x10, &r, &r, &sr);   /* call video bios          */
}



/* EOF */
